/*
 * The contents of this file are subject to the terms
 * of the Common Development and Distribution License
 * (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at
 * https://javaserverfaces.dev.java.net/CDDL.html or
 * legal/CDDLv1.0.txt.
 * See the License for the specific language governing
 * permission and limitations under the License.
 * 
 * When distributing Covered Code, include this CDDL
 * Header Notice in each file and include the License file
 * at legal/CDDLv1.0.txt.
 * If applicable, add the following below the CDDL Header,
 * with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * [Name of File] [ver.__] [Date]
 * 
 * Copyright 2006 Sun Microsystems Inc. All Rights Reserved
 */

package com.sun.faces.taglib.html_basic;

import com.sun.faces.util.Util;
import java.io.IOException;
import javax.el.*;
import javax.faces.*;
import javax.faces.component.*;
import javax.faces.context.*;
import javax.faces.convert.*;
import javax.faces.el.*;
import javax.faces.event.*;
import javax.faces.validator.*;
import javax.faces.webapp.*;
import javax.servlet.jsp.JspException;


/*
 * ******* GENERATED CODE - DO NOT EDIT *******
 */


public final class GraphicImageTag extends UIComponentELTag {


    // Setter Methods
    // PROPERTY: url
    private javax.el.ValueExpression url;
    public void setUrl(javax.el.ValueExpression url) {
        this.url = url;
    }

    // PROPERTY: value
    private javax.el.ValueExpression value;
    public void setValue(javax.el.ValueExpression value) {
        this.value = value;
    }

    // PROPERTY: alt
    private javax.el.ValueExpression alt;
    public void setAlt(javax.el.ValueExpression alt) {
        this.alt = alt;
    }

    // PROPERTY: dir
    private javax.el.ValueExpression dir;
    public void setDir(javax.el.ValueExpression dir) {
        this.dir = dir;
    }

    // PROPERTY: height
    private javax.el.ValueExpression height;
    public void setHeight(javax.el.ValueExpression height) {
        this.height = height;
    }

    // PROPERTY: ismap
    private javax.el.ValueExpression ismap;
    public void setIsmap(javax.el.ValueExpression ismap) {
        this.ismap = ismap;
    }

    // PROPERTY: lang
    private javax.el.ValueExpression lang;
    public void setLang(javax.el.ValueExpression lang) {
        this.lang = lang;
    }

    // PROPERTY: longdesc
    private javax.el.ValueExpression longdesc;
    public void setLongdesc(javax.el.ValueExpression longdesc) {
        this.longdesc = longdesc;
    }

    // PROPERTY: onclick
    private javax.el.ValueExpression onclick;
    public void setOnclick(javax.el.ValueExpression onclick) {
        this.onclick = onclick;
    }

    // PROPERTY: ondblclick
    private javax.el.ValueExpression ondblclick;
    public void setOndblclick(javax.el.ValueExpression ondblclick) {
        this.ondblclick = ondblclick;
    }

    // PROPERTY: onkeydown
    private javax.el.ValueExpression onkeydown;
    public void setOnkeydown(javax.el.ValueExpression onkeydown) {
        this.onkeydown = onkeydown;
    }

    // PROPERTY: onkeypress
    private javax.el.ValueExpression onkeypress;
    public void setOnkeypress(javax.el.ValueExpression onkeypress) {
        this.onkeypress = onkeypress;
    }

    // PROPERTY: onkeyup
    private javax.el.ValueExpression onkeyup;
    public void setOnkeyup(javax.el.ValueExpression onkeyup) {
        this.onkeyup = onkeyup;
    }

    // PROPERTY: onmousedown
    private javax.el.ValueExpression onmousedown;
    public void setOnmousedown(javax.el.ValueExpression onmousedown) {
        this.onmousedown = onmousedown;
    }

    // PROPERTY: onmousemove
    private javax.el.ValueExpression onmousemove;
    public void setOnmousemove(javax.el.ValueExpression onmousemove) {
        this.onmousemove = onmousemove;
    }

    // PROPERTY: onmouseout
    private javax.el.ValueExpression onmouseout;
    public void setOnmouseout(javax.el.ValueExpression onmouseout) {
        this.onmouseout = onmouseout;
    }

    // PROPERTY: onmouseover
    private javax.el.ValueExpression onmouseover;
    public void setOnmouseover(javax.el.ValueExpression onmouseover) {
        this.onmouseover = onmouseover;
    }

    // PROPERTY: onmouseup
    private javax.el.ValueExpression onmouseup;
    public void setOnmouseup(javax.el.ValueExpression onmouseup) {
        this.onmouseup = onmouseup;
    }

    // PROPERTY: style
    private javax.el.ValueExpression style;
    public void setStyle(javax.el.ValueExpression style) {
        this.style = style;
    }

    // PROPERTY: styleClass
    private javax.el.ValueExpression styleClass;
    public void setStyleClass(javax.el.ValueExpression styleClass) {
        this.styleClass = styleClass;
    }

    // PROPERTY: title
    private javax.el.ValueExpression title;
    public void setTitle(javax.el.ValueExpression title) {
        this.title = title;
    }

    // PROPERTY: usemap
    private javax.el.ValueExpression usemap;
    public void setUsemap(javax.el.ValueExpression usemap) {
        this.usemap = usemap;
    }

    // PROPERTY: width
    private javax.el.ValueExpression width;
    public void setWidth(javax.el.ValueExpression width) {
        this.width = width;
    }


    // General Methods
    public String getRendererType() {
        return "javax.faces.Image";
    }

    public String getComponentType() {
        return "javax.faces.HtmlGraphicImage";
    }

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        javax.faces.component.UIGraphic graphic = null;
        try {
            graphic = (javax.faces.component.UIGraphic) component;
        } catch (ClassCastException cce) {
            throw new IllegalStateException("Component " + component.toString() + " not expected type.  Expected: javax.faces.component.UIGraphic.  Perhaps you're missing a tag?");
        }

        if (url != null) {
            if (!url.isLiteralText()) {
                graphic.setValueExpression("url", url);
            } else {
                graphic.setUrl(url.getExpressionString());
            }
        }

        if (value != null) {
            if (!value.isLiteralText()) {
                graphic.setValueExpression("value", value);
            } else {
                graphic.setValue(value.getExpressionString());
            }
        }

        if (alt != null) {
            if (!alt.isLiteralText()) {
                graphic.setValueExpression("alt", alt);
            } else {
                graphic.getAttributes().put("alt", alt.getExpressionString());
            }
        }
        if (dir != null) {
            if (!dir.isLiteralText()) {
                graphic.setValueExpression("dir", dir);
            } else {
                graphic.getAttributes().put("dir", dir.getExpressionString());
            }
        }
        if (height != null) {
            if (!height.isLiteralText()) {
                graphic.setValueExpression("height", height);
            } else {
                graphic.getAttributes().put("height", height.getExpressionString());
            }
        }
        if (ismap != null) {
            if (!ismap.isLiteralText()) {
                graphic.setValueExpression("ismap", ismap);
            } else {
                graphic.getAttributes().put("ismap", java.lang.Boolean.valueOf(ismap.getExpressionString()));
            }
        }
        if (lang != null) {
            if (!lang.isLiteralText()) {
                graphic.setValueExpression("lang", lang);
            } else {
                graphic.getAttributes().put("lang", lang.getExpressionString());
            }
        }
        if (longdesc != null) {
            if (!longdesc.isLiteralText()) {
                graphic.setValueExpression("longdesc", longdesc);
            } else {
                graphic.getAttributes().put("longdesc", longdesc.getExpressionString());
            }
        }
        if (onclick != null) {
            if (!onclick.isLiteralText()) {
                graphic.setValueExpression("onclick", onclick);
            } else {
                graphic.getAttributes().put("onclick", onclick.getExpressionString());
            }
        }
        if (ondblclick != null) {
            if (!ondblclick.isLiteralText()) {
                graphic.setValueExpression("ondblclick", ondblclick);
            } else {
                graphic.getAttributes().put("ondblclick", ondblclick.getExpressionString());
            }
        }
        if (onkeydown != null) {
            if (!onkeydown.isLiteralText()) {
                graphic.setValueExpression("onkeydown", onkeydown);
            } else {
                graphic.getAttributes().put("onkeydown", onkeydown.getExpressionString());
            }
        }
        if (onkeypress != null) {
            if (!onkeypress.isLiteralText()) {
                graphic.setValueExpression("onkeypress", onkeypress);
            } else {
                graphic.getAttributes().put("onkeypress", onkeypress.getExpressionString());
            }
        }
        if (onkeyup != null) {
            if (!onkeyup.isLiteralText()) {
                graphic.setValueExpression("onkeyup", onkeyup);
            } else {
                graphic.getAttributes().put("onkeyup", onkeyup.getExpressionString());
            }
        }
        if (onmousedown != null) {
            if (!onmousedown.isLiteralText()) {
                graphic.setValueExpression("onmousedown", onmousedown);
            } else {
                graphic.getAttributes().put("onmousedown", onmousedown.getExpressionString());
            }
        }
        if (onmousemove != null) {
            if (!onmousemove.isLiteralText()) {
                graphic.setValueExpression("onmousemove", onmousemove);
            } else {
                graphic.getAttributes().put("onmousemove", onmousemove.getExpressionString());
            }
        }
        if (onmouseout != null) {
            if (!onmouseout.isLiteralText()) {
                graphic.setValueExpression("onmouseout", onmouseout);
            } else {
                graphic.getAttributes().put("onmouseout", onmouseout.getExpressionString());
            }
        }
        if (onmouseover != null) {
            if (!onmouseover.isLiteralText()) {
                graphic.setValueExpression("onmouseover", onmouseover);
            } else {
                graphic.getAttributes().put("onmouseover", onmouseover.getExpressionString());
            }
        }
        if (onmouseup != null) {
            if (!onmouseup.isLiteralText()) {
                graphic.setValueExpression("onmouseup", onmouseup);
            } else {
                graphic.getAttributes().put("onmouseup", onmouseup.getExpressionString());
            }
        }
        if (style != null) {
            if (!style.isLiteralText()) {
                graphic.setValueExpression("style", style);
            } else {
                graphic.getAttributes().put("style", style.getExpressionString());
            }
        }
        if (styleClass != null) {
            if (!styleClass.isLiteralText()) {
                graphic.setValueExpression("styleClass", styleClass);
            } else {
                graphic.getAttributes().put("styleClass", styleClass.getExpressionString());
            }
        }
        if (title != null) {
            if (!title.isLiteralText()) {
                graphic.setValueExpression("title", title);
            } else {
                graphic.getAttributes().put("title", title.getExpressionString());
            }
        }
        if (usemap != null) {
            if (!usemap.isLiteralText()) {
                graphic.setValueExpression("usemap", usemap);
            } else {
                graphic.getAttributes().put("usemap", usemap.getExpressionString());
            }
        }
        if (width != null) {
            if (!width.isLiteralText()) {
                graphic.setValueExpression("width", width);
            } else {
                graphic.getAttributes().put("width", width.getExpressionString());
            }
        }
    }
    // Methods From TagSupport
    public int doStartTag() throws JspException {
        try {
            return super.doStartTag();
        } catch (Exception e) {
            Throwable root = e;
            while (root.getCause() != null) {
                root = root.getCause();
            }
            throw new JspException(root);
        }
    }

    public int doEndTag() throws JspException {
        try {
            return super.doEndTag();
        } catch (Exception e) {
            Throwable root = e;
            while (root.getCause() != null) {
                root = root.getCause();
            }
            throw new JspException(root);
        }
    }

    // RELEASE
    public void release() {
        super.release();

        // component properties
        this.url = null;
        this.value = null;

        // rendered attributes
        this.alt = null;
        this.dir = null;
        this.height = null;
        this.ismap = null;
        this.lang = null;
        this.longdesc = null;
        this.onclick = null;
        this.ondblclick = null;
        this.onkeydown = null;
        this.onkeypress = null;
        this.onkeyup = null;
        this.onmousedown = null;
        this.onmousemove = null;
        this.onmouseout = null;
        this.onmouseover = null;
        this.onmouseup = null;
        this.style = null;
        this.styleClass = null;
        this.title = null;
        this.usemap = null;
        this.width = null;
    }

    public String getDebugString() {
        String result = "id: " + this.getId() + " class: " + this.getClass().getName();
        return result;
    }

}
