/*
 * The contents of this file are subject to the terms
 * of the Common Development and Distribution License
 * (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at
 * https://javaserverfaces.dev.java.net/CDDL.html or
 * legal/CDDLv1.0.txt.
 * See the License for the specific language governing
 * permission and limitations under the License.
 * 
 * When distributing Covered Code, include this CDDL
 * Header Notice in each file and include the License file
 * at legal/CDDLv1.0.txt.
 * If applicable, add the following below the CDDL Header,
 * with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * [Name of File] [ver.__] [Date]
 * 
 * Copyright 2006 Sun Microsystems Inc. All Rights Reserved
 */

package com.sun.faces.taglib.html_basic;

import com.sun.faces.util.Util;
import java.io.IOException;
import javax.el.*;
import javax.faces.*;
import javax.faces.component.*;
import javax.faces.context.*;
import javax.faces.convert.*;
import javax.faces.el.*;
import javax.faces.event.*;
import javax.faces.validator.*;
import javax.faces.webapp.*;
import javax.servlet.jsp.JspException;


/*
 * ******* GENERATED CODE - DO NOT EDIT *******
 */


public final class MessageTag extends UIComponentELTag {


    // Setter Methods
    // PROPERTY: for
    private javax.el.ValueExpression _for;
    public void setFor(javax.el.ValueExpression _for) {
        this._for = _for;
    }

    // PROPERTY: showDetail
    private javax.el.ValueExpression showDetail;
    public void setShowDetail(javax.el.ValueExpression showDetail) {
        this.showDetail = showDetail;
    }

    // PROPERTY: showSummary
    private javax.el.ValueExpression showSummary;
    public void setShowSummary(javax.el.ValueExpression showSummary) {
        this.showSummary = showSummary;
    }

    // PROPERTY: dir
    private javax.el.ValueExpression dir;
    public void setDir(javax.el.ValueExpression dir) {
        this.dir = dir;
    }

    // PROPERTY: errorClass
    private javax.el.ValueExpression errorClass;
    public void setErrorClass(javax.el.ValueExpression errorClass) {
        this.errorClass = errorClass;
    }

    // PROPERTY: errorStyle
    private javax.el.ValueExpression errorStyle;
    public void setErrorStyle(javax.el.ValueExpression errorStyle) {
        this.errorStyle = errorStyle;
    }

    // PROPERTY: fatalClass
    private javax.el.ValueExpression fatalClass;
    public void setFatalClass(javax.el.ValueExpression fatalClass) {
        this.fatalClass = fatalClass;
    }

    // PROPERTY: fatalStyle
    private javax.el.ValueExpression fatalStyle;
    public void setFatalStyle(javax.el.ValueExpression fatalStyle) {
        this.fatalStyle = fatalStyle;
    }

    // PROPERTY: infoClass
    private javax.el.ValueExpression infoClass;
    public void setInfoClass(javax.el.ValueExpression infoClass) {
        this.infoClass = infoClass;
    }

    // PROPERTY: infoStyle
    private javax.el.ValueExpression infoStyle;
    public void setInfoStyle(javax.el.ValueExpression infoStyle) {
        this.infoStyle = infoStyle;
    }

    // PROPERTY: lang
    private javax.el.ValueExpression lang;
    public void setLang(javax.el.ValueExpression lang) {
        this.lang = lang;
    }

    // PROPERTY: style
    private javax.el.ValueExpression style;
    public void setStyle(javax.el.ValueExpression style) {
        this.style = style;
    }

    // PROPERTY: styleClass
    private javax.el.ValueExpression styleClass;
    public void setStyleClass(javax.el.ValueExpression styleClass) {
        this.styleClass = styleClass;
    }

    // PROPERTY: title
    private javax.el.ValueExpression title;
    public void setTitle(javax.el.ValueExpression title) {
        this.title = title;
    }

    // PROPERTY: tooltip
    private javax.el.ValueExpression tooltip;
    public void setTooltip(javax.el.ValueExpression tooltip) {
        this.tooltip = tooltip;
    }

    // PROPERTY: warnClass
    private javax.el.ValueExpression warnClass;
    public void setWarnClass(javax.el.ValueExpression warnClass) {
        this.warnClass = warnClass;
    }

    // PROPERTY: warnStyle
    private javax.el.ValueExpression warnStyle;
    public void setWarnStyle(javax.el.ValueExpression warnStyle) {
        this.warnStyle = warnStyle;
    }


    // General Methods
    public String getRendererType() {
        return "javax.faces.Message";
    }

    public String getComponentType() {
        return "javax.faces.HtmlMessage";
    }

    protected void setProperties(UIComponent component) {
        super.setProperties(component);
        javax.faces.component.UIMessage message = null;
        try {
            message = (javax.faces.component.UIMessage) component;
        } catch (ClassCastException cce) {
            throw new IllegalStateException("Component " + component.toString() + " not expected type.  Expected: javax.faces.component.UIMessage.  Perhaps you're missing a tag?");
        }

        if (_for != null) {
            if (!_for.isLiteralText()) {
                message.setValueExpression("_for", _for);
            } else {
                message.setFor(_for.getExpressionString());
            }
        }

        if (showDetail != null) {
            if (!showDetail.isLiteralText()) {
                message.setValueExpression("showDetail", showDetail);
            } else {
                message.setShowDetail(java.lang.Boolean.valueOf(showDetail.getExpressionString()).booleanValue());
            }
        }

        if (showSummary != null) {
            if (!showSummary.isLiteralText()) {
                message.setValueExpression("showSummary", showSummary);
            } else {
                message.setShowSummary(java.lang.Boolean.valueOf(showSummary.getExpressionString()).booleanValue());
            }
        }

        if (dir != null) {
            if (!dir.isLiteralText()) {
                message.setValueExpression("dir", dir);
            } else {
                message.getAttributes().put("dir", dir.getExpressionString());
            }
        }
        if (errorClass != null) {
            if (!errorClass.isLiteralText()) {
                message.setValueExpression("errorClass", errorClass);
            } else {
                message.getAttributes().put("errorClass", errorClass.getExpressionString());
            }
        }
        if (errorStyle != null) {
            if (!errorStyle.isLiteralText()) {
                message.setValueExpression("errorStyle", errorStyle);
            } else {
                message.getAttributes().put("errorStyle", errorStyle.getExpressionString());
            }
        }
        if (fatalClass != null) {
            if (!fatalClass.isLiteralText()) {
                message.setValueExpression("fatalClass", fatalClass);
            } else {
                message.getAttributes().put("fatalClass", fatalClass.getExpressionString());
            }
        }
        if (fatalStyle != null) {
            if (!fatalStyle.isLiteralText()) {
                message.setValueExpression("fatalStyle", fatalStyle);
            } else {
                message.getAttributes().put("fatalStyle", fatalStyle.getExpressionString());
            }
        }
        if (infoClass != null) {
            if (!infoClass.isLiteralText()) {
                message.setValueExpression("infoClass", infoClass);
            } else {
                message.getAttributes().put("infoClass", infoClass.getExpressionString());
            }
        }
        if (infoStyle != null) {
            if (!infoStyle.isLiteralText()) {
                message.setValueExpression("infoStyle", infoStyle);
            } else {
                message.getAttributes().put("infoStyle", infoStyle.getExpressionString());
            }
        }
        if (lang != null) {
            if (!lang.isLiteralText()) {
                message.setValueExpression("lang", lang);
            } else {
                message.getAttributes().put("lang", lang.getExpressionString());
            }
        }
        if (style != null) {
            if (!style.isLiteralText()) {
                message.setValueExpression("style", style);
            } else {
                message.getAttributes().put("style", style.getExpressionString());
            }
        }
        if (styleClass != null) {
            if (!styleClass.isLiteralText()) {
                message.setValueExpression("styleClass", styleClass);
            } else {
                message.getAttributes().put("styleClass", styleClass.getExpressionString());
            }
        }
        if (title != null) {
            if (!title.isLiteralText()) {
                message.setValueExpression("title", title);
            } else {
                message.getAttributes().put("title", title.getExpressionString());
            }
        }
        if (tooltip != null) {
            if (!tooltip.isLiteralText()) {
                message.setValueExpression("tooltip", tooltip);
            } else {
                message.getAttributes().put("tooltip", java.lang.Boolean.valueOf(tooltip.getExpressionString()));
            }
        }
        if (warnClass != null) {
            if (!warnClass.isLiteralText()) {
                message.setValueExpression("warnClass", warnClass);
            } else {
                message.getAttributes().put("warnClass", warnClass.getExpressionString());
            }
        }
        if (warnStyle != null) {
            if (!warnStyle.isLiteralText()) {
                message.setValueExpression("warnStyle", warnStyle);
            } else {
                message.getAttributes().put("warnStyle", warnStyle.getExpressionString());
            }
        }
    }
    // Methods From TagSupport
    public int doStartTag() throws JspException {
        try {
            return super.doStartTag();
        } catch (Exception e) {
            Throwable root = e;
            while (root.getCause() != null) {
                root = root.getCause();
            }
            throw new JspException(root);
        }
    }

    public int doEndTag() throws JspException {
        try {
            return super.doEndTag();
        } catch (Exception e) {
            Throwable root = e;
            while (root.getCause() != null) {
                root = root.getCause();
            }
            throw new JspException(root);
        }
    }

    // RELEASE
    public void release() {
        super.release();

        // component properties
        this._for = null;
        this.showDetail = null;
        this.showSummary = null;

        // rendered attributes
        this.dir = null;
        this.errorClass = null;
        this.errorStyle = null;
        this.fatalClass = null;
        this.fatalStyle = null;
        this.infoClass = null;
        this.infoStyle = null;
        this.lang = null;
        this.style = null;
        this.styleClass = null;
        this.title = null;
        this.tooltip = null;
        this.warnClass = null;
        this.warnStyle = null;
    }

    public String getDebugString() {
        String result = "id: " + this.getId() + " class: " + this.getClass().getName();
        return result;
    }

}
